#!/bin/bash
# create-cert.sh: script for making self-signed X.509 certificate
# created by Mustafa OZGUR (www.panilux.com)

SSL_NAME="$1";
if [ -z "${SSL_NAME}" ]; then
    echo "missing ssl_file_name argument";
fi

CONF_FILE="$2";
if [ -z "${CONF_FILE}" ]; then
    CONF_FILE="/panilux/bin/create-cert-default.conf";
fi

JUST_REQUEST="$3";

openssl genrsa -out /sites/ssls/${SSL_NAME}.key 2048
openssl req -new -nodes -config ${CONF_FILE} -key /sites/ssls/${SSL_NAME}.key -out /sites/ssls/${SSL_NAME}.csr

if [ ! ${JUST_REQUEST} ]; then
    openssl x509 -req -days 3650 -in /sites/ssls/${SSL_NAME}.csr -signkey /sites/ssls/${SSL_NAME}.key -out /sites/ssls/${SSL_NAME}.crt
fi
