#!/bin/bash
# mail-restart.sh: Panilux Postfix and Dovecot services restart|reload|start|stop script.

RETVAL_POSTFIX=0
RETVAL_SASLAUTHD=0
RETVAL_DOVECOT=0
RETVAL_SPAM=0
RETVAL_DKIM=0

COMMAND=$1

if [ ! ${COMMAND} ]; then
	echo "start, stop, status, restart, reload"
	exit 1
fi

echo -n "${COMMAND} mail-services... "

function doCommand()
{
	SERVICE_NAME=$1

	service ${SERVICE_NAME} status >/dev/null; STATUS=$?

	if [ ${COMMAND} == "start" ]; then
		if [ ${STATUS} == 0 ]; then
			RETVAL=0
		else
			service ${SERVICE_NAME} ${COMMAND} >/dev/null
			RETVAL=$?
		fi
	else
		service ${SERVICE_NAME} ${COMMAND} >/dev/null
		RETVAL=$?
	fi

	return ${RETVAL}
}

doCommand "opendkim"; RETVAL_DKIM=$?
doCommand "spamassassin"; RETVAL_SPAM=$?
doCommand "dovecot"; RETVAL_DOVECOT=$?
doCommand "saslauthd"; RETVAL_SASLAUTHD=$?
doCommand "postfix"; RETVAL_POSTFIX=$?

if
	[ ${RETVAL_POSTFIX} == 0 ]
	[ ${RETVAL_SASLAUTHD} == 0 ]
	[ ${RETVAL_DOVECOT} == 0 ]
	[ ${RETVAL_SPAM} == 0 ]
	[ ${RETVAL_DKIM} == 0 ]
then
	exitval=0
	echo "[ OK ]"
else
	exitval=1
	echo "[ FAIL ]"
fi

exit ${exitval}
exit
