var lang_keys = {
	'server-loads-increase-a-little-bit-while-you-are-displaying-server-loads-at-the-panel': '#{server-loads-increase-a-little-bit-while-you-are-displaying-server-loads-at-the-panel}',

	'show-hide-server-load': '#{show-hide-server-load}',
	'api-error'            : '#{api-error}',
	'error-code'           : '#{error-code}',
	'error-message'        : '#{error-message}',
	'api-in-progress'      : '#{api-in-progress}',
	'outbound-ip'          : '#{outbound-ip}',
	'set-outbound-ip'      : '#{set-outbound-ip}',
	'be-deleted'           : '#{be-deleted}',
	'saved'                : '#{saved}',
	'required'             : '#{required}',
	'hide-loads'           : '#{hide-loads}',
	'show-loads'           : '#{show-loads}',
	'loading'              : '#{loading}',
	'are-you-sure'         : '#{are-you-sure}',
	'submit'               : '#{submit}',
	'yes'                  : '#{yes}',
	'no'                   : '#{no}',
	'ok'                   : '#{ok}',
	'back'                 : '#{back}',
	'next'                 : '#{next}',
	'none'                 : '#{none}',
	'upload-success'       : '#{upload-success}',
	'upload-file'          : '#{upload-file}',
	'parent-folder'        : '#{parent-folder}',

	'create-directory' : '#{create-directory}',
	'delete'           : '#{delete}',
	'permission-denied': '#{permission-denied}',
	'close'            : '#{close}',
	'create'           : '#{create}',
	'change'           : '#{change}',
	'succeed'          : '#{succeed}',
	'save'             : '#{save}',
	'failed'           : '#{failed}',
	'success'          : '#{success}',
	'refreshing'       : '#{refreshing}',
	'generating'       : '#{generating}',
	'sending'          : '#{sending}',

	'no-results-found'                           : '#{no-results-found}',
	'domain'                                     : '#{domain}',
	'email'                                      : '#{email}',
	'database'                                   : '#{database}',
	'license-checked'                            : '#{license-checked}',
	'panilux-have-a-update'                      : '#{panilux-have-a-update}',
	'update'                                     : '#{update}',
	'session-timed-out'                          : '#{session-timed-out}',
	'username-can-not-be-empty'                  : '#{username-can-not-be-empty}',
	'username-is-not-valid'                      : '#{username-is-not-valid}',
	'username-min-6-max-32-char-and-alphanumeric': '#{username-min-6-max-32-char-and-alphanumeric}',
	'username-exists'                            : '#{username-exists}',
	'you-have-unsaved-changes'                   : '#{you-have-unsaved-changes}',
	'feedback'                                   : '#{feedback}',
	'feedback-welcome-1'                         : '#{feedback-welcome-1}',
	'feedback-welcome-2'                         : '#{feedback-welcome-2}',
	'feedback-welcome-3'                         : '#{feedback-welcome-3}',
	'description'                                : '#{description}',
	'feedback-highlighter-1'                     : '#{feedback-highlighter-1}',
	'feedback-highlight'                         : '#{feedback-highlight}',
	'feedback-highlighter-2'                     : '#{feedback-highlighter-2}',
	'feedback-blackout'                          : '#{feedback-blackout}',
	'feedback-highlighter-3'                     : '#{feedback-highlighter-3}',
	'contact-email'                              : '#{contact-email}',
	'additional-info'                            : '#{additional-info}',
	'browser-info'                               : '#{browser-info}',
	'page-info'                                  : '#{page-info}',
	'page-structure'                             : '#{page-structure}',
	'screenshot'                                 : '#{screenshot}',
	'please-enter-a-description'                 : '#{please-enter-a-description}',
	'feedback-submit-success-1'                  : '#{feedback-submit-success-1}',
	'feedback-submit-success-2'                  : '#{feedback-submit-success-2}',
	'feedback-submit-error-1'                    : '#{feedback-submit-error-1}',
	'send-feedback'                              : '#{send-feedback}',
	'console-warning-1'                          : '#{console-warning-1}',
	'console-warning-2'                          : '@json_encode{console-warning-2}',
	'console-warning-3'                          : '#{console-warning-3}',
	'this-file-is-not-a-panilux-backup-file'     : '#{this-file-is-not-a-panilux-backup-file}',
	'file-is-too-big-x-max-filesize-x'           : '#{file-is-too-big-x-max-filesize-x [[filesize]]MB~~[[maxFilesize]]MB}'
};

function lang(key, default_text)
{
	var lang_str = default_text || key;

	if (typeof lang_keys[key] != 'undefined')
	{
		lang_str = lang_keys[key];
	}

	return lang_str;
}

$(function ()
{
	if ($('#sidebar'))
	{
		$(window).resize(init_sidebar_side);
	}

	if ($.feedback)
	{
		$.feedback({
			ajaxURL       : '/do.php?c=send_feedback',
			html2canvasURL: '/assets/scripts/feedback/html2canvas.min.js',
			tpl           : {
				description  : '<div id="feedback-welcome"><div class="feedback-logo">' + lang('feedback') + '</div><p>' + lang('feedback-welcome-1') + '</p><p>' + lang('feedback-welcome-2') + ':</p><textarea id="feedback-note-tmp"></textarea><p>' + lang('feedback-welcome-3') + '</p><button id="feedback-welcome-next" class="feedback-next-btn btn btn-primary">' + lang('next') + '</button><div id="feedback-welcome-error">' + lang('description') + '.</div><div class="feedback-wizard-close"></div></div>',
				highlighter  : '<div id="feedback-highlighter"><div class="feedback-logo">' + lang('feedback') + '</div><p>' + lang('feedback-highlighter-1') + '</p><button class="feedback-sethighlight btn feedback-active"><div class="ico"></div><span>' + lang('feedback-highlight') + '</span></button><label>' + lang('feedback-highlighter-2') + '</label><button class="feedback-setblackout btn"><div class="ico"></div><span>' + lang('feedback-blackout') + '</span></button><label class="lower">' + lang('feedback-highlighter-3') + '</label><div class="feedback-buttons"><button id="feedback-highlighter-next" class="feedback-next-btn btn btn-primary">' + lang('next') + '</button><button id="feedback-highlighter-back" class="feedback-back-btn btn">' + lang('back') + '</button></div><div class="feedback-wizard-close"></div></div>',
				overview     : '<div id="feedback-overview"><div class="feedback-logo">' + lang('feedback') + '</div><div id="feedback-overview-description"><h3>' + lang('contact-email') + '</h3><input type="email" name="feedback_email" id="feedback_email" value="' + admin_email + '" placeholder="' + lang('email') + '..."><div id="feedback-overview-description-text"><h3>' + lang('description') + '</h3><h3 class="feedback-additional">' + lang('additional-info') + '</h3><div id="feedback-additional-none"><span>' + lang('none') + '</span></div><div id="feedback-panilux-info"><span>Panilux</span></div><div id="feedback-browser-info"><span>' + lang('browser-info') + '</span></div><div id="feedback-page-info"><span>' + lang('page-info') + '</span></div><div id="feedback-page-structure"><span>' + lang('page-structure') + '</span></div></div></div><div id="feedback-overview-screenshot"><h3>' + lang('screenshot') + '</h3></div><div class="feedback-buttons"><button id="feedback-submit" class="feedback-submit-btn btn btn-primary">' + lang('submit') + '</button><button id="feedback-overview-back" class="feedback-back-btn btn">' + lang('back') + '</button></div><div id="feedback-overview-error">' + lang('please-enter-a-description') + '</div><div class="feedback-wizard-close"></div></div>',
				submitSuccess: '<div id="feedback-submit-success"><div class="feedback-logo">' + lang('feedback') + '</div><p>' + lang('feedback-submit-success-1') + '</p><p>' + lang('feedback-submit-success-2') + '</p><button class="feedback-close-btn btn btn-primary">' + lang('ok') + '</button><div class="feedback-wizard-close"></div></div>',
				submitError  : '<div id="feedback-submit-error"><div class="feedback-logo">' + lang('feedback') + '</div><p>' + lang('feedback-submit-error-1') + '</p><button class="feedback-close-btn btn btn-primary">' + lang('ok') + '</button><div class="feedback-wizard-close"></div></div>'
			},
			initButtonText: lang('send-feedback')
		});
	}

	$(document).mouseup(function (e)
	{
		var container = $('#panilux_search_container'), link = $('#panilux_search_link');

		if (!link.is(e.target) && link.has(e.target).length === 0 && !container.is(e.target) && container.has(e.target).length === 0)
		{
			panilux_search_hide();
		}
	});

	Mousetrap.bind(['ctrl+space', 'ctrl+f', 'command+space', 'command+f'], function ()
	{
		panilux_search_show();
		panilux_search_run();
	});

	$('#panilux_search_container').css({'left': $('#_x_main_container').width() / 2 - 170});

	if (conf_show_loads)
	{
		p_load();
	}

	if ($('#button_p_server_load').length)
	{
		$('#button_p_server_load').popover({
			title    : lang('show-hide-server-load'),
			content  : lang('server-loads-increase-a-little-bit-while-you-are-displaying-server-loads-at-the-panel'),
			container: 'body',
			trigger  : 'hover',
			placement: 'bottom'
		});
	}

	$(window).on('beforeunload', function ()
	{
		rotate_logo();
	});

	if (typeof settings_push_noficitation_enabled != 'undefined' && settings_push_noficitation_enabled)
	{
		window.setTimeout('pnlx_check_commands()', 10000);
	}

	init_all();

	console_warning();
});