var notify_default_success_timeout = 3000, notify_hide_default_timeout = 300;

function panilux_notify(text, type)
{
	if (type == 'success')
	{
		notify_success(text);
	}
	else if (type == 'error')
	{
		notify_error(text);
	}
	else if (type == 'info')
	{
		notify_info(text);
	}
	else if (type == 'warning')
	{
		notify_warning(text);
	}
}

function notify_success(title, callback, timeout)
{
	callback = callback || null;
	timeout = timeout || notify_default_success_timeout;

	panilux_alert_container_change_class('alert-success');
	panilux_alert_title_change(title);
	show_notify();
	window.setTimeout(function ()
	{
		hide_notify(callback);
	}, timeout);
}

function notify_error(title)
{
	panilux_alert_container_change_class('alert-error');
	panilux_alert_title_change(title);
	show_notify();
}

function notify_info(title)
{
	panilux_alert_container_change_class('alert-info');
	panilux_alert_title_change(title);
	show_notify();
}

function notify_warning(title)
{
	panilux_alert_container_change_class('alert-warning');
	panilux_alert_title_change(title);
	show_notify();
}

function panilux_alert_container_change_class(class_name)
{
	$('.panilux_alert_container > div.alert').removeClass('alert-success alert-error alert-info alert-warning').addClass(class_name);
}

function panilux_alert_title_change(title)
{
	$('.panilux_alert > span.panilux_alert_title').html(title);
}

function hide_notify(callback)
{
	callback = callback || null;

	$('.panilux_alert_container').removeClass('show_pa').addClass('show_pa_rvhide');

	if (typeof callback == 'function')
	{
		window.setTimeout(callback, notify_hide_default_timeout);
	}

	window.setTimeout('panilux_alert_reset()', notify_hide_default_timeout);
}

function hide_zone_notify(callback)
{
	callback = callback || null;

	$('.panilux_notify_zone').html('');

	if (typeof callback == 'function')
	{
		window.setTimeout(callback, notify_hide_default_timeout);
	}

	window.setTimeout('panilux_alert_reset()', notify_hide_default_timeout);
}

function panilux_alert_reset()
{
	var container = $('.panilux_alert_container');

	container.addClass('show_pa_hide').removeClass('show_pa show_pa_rvhide');
	panilux_alert_title_change('');
	panilux_alert_container_change_class('');

	$('.panilux_alert').css('display', 'none');

	container.removeClass('show_pa_hide').css('visibility', 'hidden');
	window.setTimeout("$('.panilux_alert').css('display', 'inline-block')", notify_hide_default_timeout);
}

function show_notify()
{
	var container = $('.panilux_alert_container');

	if ($('#index_header').length == 0)
	{
		container.css('top', '-66px');
	}

	container.css('visibility', 'visible');

	if (container.hasClass('show_pa'))
	{
		container.addClass('shake');

		window.setTimeout("$('.panilux_alert_container').removeClass('shake')", 400);
	}
	else
	{
		container.addClass('show_pa');
	}
}

function message_success(message_text, callback, timeout)
{
	notify_success(message_text, callback, timeout);
}

function message_error(message_text)
{
	notify_error(message_text);
}

function message_info(message_text)
{
	notify_info(message_text);
}

function message_notify(message_text)
{
	notify_warning(message_text);
}

$(function ()
{
	$('body').append('<div class="panilux_alert_container"><div class="alert panilux_alert"><button type="button" class="close" onclick="hide_notify()">&times;</button><span class="panilux_alert_title"></span></div></div>');
});