function panilux_modal(obj)
{
	if (typeof obj == 'string')
	{
		if (obj == 'show')
		{
			$('#panilux_modal').modal('show');
		}
		else if (obj == 'hide')
		{
			$('#panilux_modal').modal('hide');
		}
		else if (obj == 'reset')
		{
			$('#panilux_modal_submit_button').removeLoading();
			window.setTimeout("$('#panilux_modal_submit_button').removeLoading();", 50);
		}
	}
	else
	{
		var panilux_modal_plain = $('#panilux_modal_plain');
		var modal = $('#panilux_modal');
		var panilux_modal_body = $('#panilux_modal_body');
		var panilux_modal_cancel_button = $('#panilux_modal_cancel_button');
		var panilux_modal_submit_button = $('#panilux_modal_submit_button');

		modal.off('hide');
		modal.off('hidden');
		modal.off('show');
		modal.off('shown');

		var title = obj.title;
		var body = obj.body;
		var func_shown = obj.shown;
		var func_hidden = obj.hidden;
		var backdrop_dont_hide = obj.backdrop_dont_hide;
		var modal_width = obj.width;
		var modal_height = obj.height;
		var modal_confirm = obj.modal_confirm || false;
		var backgroundStyle = obj.backgroundStyle || '';

		modal.removeClass('error success warning info');

		if (backgroundStyle)
		{
			modal.addClass(backgroundStyle);
		}

		var show_plain = typeof obj.body_plain == 'boolean' && obj.body_plain == true;

		if (!show_plain)
		{
			if (typeof title != 'undefined')
			{
				$('#panilux_modal_title').html(title);
			}
			else
			{
				$('#panilux_modal_title').html('');
			}

			if (typeof obj.submit == 'boolean' && obj.submit == false)
			{
				panilux_modal_submit_button.hide();
			}
			else if (typeof obj.submit_text == 'string' && obj.submit_text != '')
			{
				panilux_modal_submit_button.html(obj.submit_text);
			}

			if (typeof obj.cancel == 'boolean' && obj.cancel == false)
			{
				panilux_modal_cancel_button.hide();
			}
			else if (typeof obj.cancel_text == 'string' && obj.cancel_text != '')
			{
				panilux_modal_cancel_button.html(obj.cancel_text);
			}

			if (modal_confirm)
			{
				panilux_modal_submit_button.on('click', function ()
				{
					obj.submit(true);
				});

				panilux_modal_cancel_button.on('click', function ()
				{
					obj.submit(false);
				});
			}
			else
			{
				if (typeof obj.submit == 'function')
				{
					panilux_modal_submit_button.on('click', obj.submit);
				}
				else if (typeof obj.submit == 'string')
				{
					panilux_modal_submit_button.on('click', 'function(){' + obj.submit + '}');
				}
				else
				{
					panilux_modal_submit_button.hide();
				}

				if (typeof obj.cancel == 'function')
				{
					panilux_modal_cancel_button.on('click', obj.cancel);
				}
				else if (typeof obj.cancel == 'string')
				{
					panilux_modal_cancel_button.on('click', 'function(){' + obj.cancel + '}');
				}
			}

			panilux_modal_cancel_button.on('click', function ()
			{
				$('#panilux_modal').modal('hide');
			});

			if (typeof body == 'string')
			{
				panilux_modal_body.html(body);
			}
			else if (typeof body == 'object')
			{
				body.detach().appendTo('#panilux_modal_body');
				body.show();
			}
		}
		else
		{
			if (typeof body == 'string')
			{
				panilux_modal_plain.html(body);
			}
			else if (typeof body == 'object')
			{
				body.detach().appendTo('#panilux_modal_plain');
				body.show();
			}

			modal = panilux_modal_plain;
		}
/////
		modal.on('show', function ()
		{
			hide_notify();

			$('#_x_main_container').addClass('blur');

			//$('.panilux_modal_container').css('display', 'block').css('margin-top', -1 * ($('#panilux_modal').height() / 2));
			$('.panilux_modal_container').css('display', 'block');

			$('body').addClass('panilux-model-open');
		});

		modal.on('shown', function ()
		{
			var alert_container = $('.panilux_alert_container');

			if ($('#index_header').length == 0)
			{
				alert_container.css('top', modal.offset().top);
			}
			else
			{
				alert_container.css('top', (parseInt(modal.offset().top) - 99) + 'px');
			}

			alert_container.css({
				'z-index': '1010'
			});

			$('.panilux_alert').css({
				'border-radius'        : '5px 5px 0px 0px',
				'width'                : (modal.width() - 50) + 'px',
				'transform-origin'     : 'bottom',
				'-moz-transform-origin': 'bottom',
				'-ms-transform-origin' : 'bottom',
				'-o-transform-origin'  : 'bottom'
			});

			if (typeof obj.focus == 'string')
			{
				$('#' + obj.focus).focus();
			}
			else if (typeof obj.focus == 'object')
			{
				obj.focus.focus();
			}
			else if (typeof obj.focus == 'undefined')
			{
				panilux_modal_body.find('input:first').focus();
			}

			if (typeof func_shown == 'function')
			{
				func_shown();
			}

			init_all();
		});

		modal.on('hide', function ()
		{
			$('#panilux_modal').addClass('out');
		});

		modal.on('hidden', function ()
		{
			var alert_container = $('.panilux_alert_container');

			$('body').removeClass('panilux-model-open');

			if ($('#index_header').length == 0)
			{
				alert_container.css('top', '-66px');
			}
			else
			{
				alert_container.css('top', '0px');
			}

			alert_container.css({
				'z-index': '900'
			});

			$('.panilux_alert').css({
				'top'                  : '65px',
				'border-radius'        : '0px 0px 5px 5px',
				'width'                : '500px',
				'transform-origin'     : 'top',
				'-moz-transform-origin': 'top',
				'-ms-transform-origin' : 'top',
				'-o-transform-origin'  : 'top'
			});

			$('#_x_main_container').removeClass('blur');

			if (typeof func_hidden == 'function')
			{
				func_hidden();
			}

			if (typeof body == 'string')
			{
				panilux_modal_body.html('');
			}
			else if (typeof body == 'object')
			{
				body.detach().appendTo('body');
			}

			$(this).removeClass('out');

			$('.panilux_modal_container').css('display', 'none');
			if (typeof body == 'object')
			{
				body.hide();
			}
			$('#panilux_modal_submit_button').removeLoading();

			panilux_modal_submit_button.off('click');
			panilux_modal_cancel_button.off('click');
		});

		if (typeof backdrop_dont_hide != 'undefined')
		{
			modal.attr('data-backdrop', 'static');
			modal.attr('data-keyboard', 'false');
		}

		if (modal_width)
		{
			panilux_modal_body.css('width', modal_width);
		}

		if (modal_height)
		{
			panilux_modal_body.css('height', modal_height);
		}

		hide_notify();

		modal.modal('show');
	}
	return true;
}

function modal(modal_url, data)
{
	data = data || '';

	modal_url = modal_url.replace(/^\//g, '');

	if (modal_url.indexOf('?') >= 0)
	{
		modal_url += '&__noheader=true'
	}
	else
	{
		modal_url += '?__noheader=true'
	}

	$.ajax({
		url     : '/' + modal_url + (data != '' ? '&' + data : ''),
		complete: function (data)
		{
			if (data.status == 200)
			{
				if (data.responseText.indexOf('panilux_data___login_needed') >= 0)
				{
					panilux_modal({
						body_plain        : true,
						body              : data.responseText,
						backdrop_dont_hide: true,
						width             : '320px',
						height            : '230px'
					});
				}
				else
				{
					panilux_modal({
						body      : data.responseText,
						body_plain: true
					});
				}
			}
			else
			{
				message_error('#{api-error}');
			}
		}
	});
}

function modal_with_submit(modal_url, title, submit, submit_text)
{
	title = title || '';
	submit = submit || '';
	submit_text = submit_text || '';

	modal_url = modal_url.replace(/^\//g, '');

	if (modal_url.indexOf('?') >= 0)
	{
		modal_url += '&__noheader=true'
	}
	else
	{
		modal_url += '?__noheader=true'
	}

	$.ajax({
		url     : '/' + modal_url,
		complete: function (data)
		{
			if (data.status == 200)
			{
				if (data.responseText.indexOf('panilux_data___login_needed') >= 0)
				{
					panilux_modal({
						body_plain        : true,
						body              : data.responseText,
						backdrop_dont_hide: true,
						width             : '320px',
						height            : '230px'
					});
				}
				else
				{
					panilux_modal({
						title      : title,
						body       : data.responseText,
						submit     : submit,
						submit_text: submit_text
					});
				}
			}
			else
			{
				message_error('#{api-error}');
			}
		}
	});
}